//form id
var form_id = 'survey';
//slider
var sliderEl = $('.pages');

//blocks
var blocks = jsonfile.blocks;
var blocks_count = jsonfile.blocks.length;

var random_pages = false;
var random_items = false;
var consideration_page = false;
var consideration_include_text = true;

var tracker_count = 0;

var trackedGroups = new Map();

var FilenamePrefix = (jsonfile.hasOwnProperty('mandatory') && jsonfile.mandatory.hasOwnProperty('FilenamePrefix')) ? jsonfile.mandatory.FilenamePrefix : 'survey';
var TrialID = (jsonfile.hasOwnProperty('mandatory') && jsonfile.mandatory.hasOwnProperty('TrialID')) ? jsonfile.mandatory.TrialID : '0000';
var UIDrandom = Math.floor(Math.random() * 1000000000000000000);
var CurrentDate = new Date();
var CurrentDateMil = Date.parse(CurrentDate);
var CurrentDateFormat = CurrentDate.getFullYear() + "-"
  + ('0' + (CurrentDate.getMonth() + 1)).slice(-2) + "-"
  + ('0' + CurrentDate.getDate()).slice(-2) + "T"
  + ('0' + CurrentDate.getHours()).slice(-2) + ":"
  + ('0' + CurrentDate.getMinutes()).slice(-2) + ":"
  + ('0' + CurrentDate.getSeconds()).slice(-2);

//console.log(FilenamePrefix);

//sort object
function sortObject(o) {
  var sorted = {},
    key, a = [];

  for (key in o) {
    if (o.hasOwnProperty(key)) {
      a.push(key);
    }
  }

  a.sort();

  for (key = 0; key < a.length; key++) {
    sorted[a[key]] = o[a[key]];
  }
  return sorted;
}


//parse blocks
function parseBlocks(pages, random_pages, pages_count) {

  //randomize order of pages
  if (random_pages == true) {
    pages = pages.sort(function () {
      return .5 - Math.random();
    });
  }

  //loop through pages
  //console.log('---pages---');
  //console.log(pages);

  //for (var i = 0; i < pages_count; i++){
  $.each(pages, function (i, items) {
    var pagenumber = pages_count + i;
    var items = pages[i].items;
    var items_count = pages[i].items.length;
    var page = '<div id="p-' + pagenumber + '" class="page"></div>';
    $('#' + form_id).find('.pages').append(page);

    //console.log(items);

    for (var a = 0; a < items_count; a++) {

      //console.log(items[a]);

      var multipleClass = items[a].type === 'tracker' && items[a].items.length > 2 ? 'multiple' : '';
      var item = '<div id="item-' + items[a].id + '" class="item ' + items[a].type + ' ' + multipleClass + '" data-type="' + items[a].type + '"></div>';

      //check if is ref item -- ref item belongs to a tracker
      var ref = items[a].ref;

      if (typeof ref != "undefined") {
        //console.log('ref has ref with value ' + items[a].ref);
        item = '<div id="item-' + items[a].id + '" class="item ' + items[a].type + ' ref hide" data-type="' + items[a].type + '"></div>';
      }

      //add div for each item

      $('#p-' + pagenumber).append(item);


      //add elements depending on content type

      //textinput
      if (items[a].type == 'textinput') {
        var content = '<label for="' + items[a].id + '">' + items[a].text + '</label></br>';
        var input = '<input id="' + items[a].id + '" name="' + items[a].id + '" type="text" />'
        $('#item-' + items[a].id).append(content, input);
      }

      //likert
      if (items[a].type == 'likert') {

        var quantity = '<input id="item-' + items[a].id + '-quantity" class="hide" name="' + items[a].id + '-quantity" type="text" value="' + items[a].number_selectors + '" />';
        $('#item-' + items[a].id).append(quantity);
        var likert_question = '<p>' + items[a].question + '</p>'
        var likert = '<ul class="likert-group"></ul>';
        var caption_left = '<li>' + items[a].caption_left + '</li>';
        var caption_right = '<li>' + items[a].caption_right + '</li>';
        var number_selectors = parseInt(items[a].number_selectors);

        $('#item-' + items[a].id).append(likert_question).append(likert);
        $('#item-' + items[a].id).find('.likert-group').append(caption_left);

        for (z = 0; z < number_selectors; z++) {

          var item_selector = '<li><input type="radio" name="' + items[a].id + '" value="' + z + '" /></li>';
          $('#item-' + items[a].id).find('.likert-group').append(item_selector);

        }

        $('#item-' + items[a].id).find('.likert-group').append(caption_right);

      }

      //pic
      if (items[a].type == 'pic') {
        var content = '<img src="' + items[a].url + '">';
        $('#item-' + items[a].id).append(content);
      }

      //text
      if (items[a].type == 'infotext') {
        var content = '<p>' + items[a].text + '</p>';
        $('#item-' + items[a].id).append(content);
      }

      //tracker
      if (items[a].type == 'tracker') {

        tracker_count++;

        var content = '';

        var input_xpos = '<input id="item-' + items[a].id + '-xpos" class="hide" name="' + items[a].id + '-xpos" type="text" />';
        //$('#item-'+items[a].id).append(input_xpos);
        content += input_xpos;

        var input_ypos = '<input id="item-' + items[a].id + '-ypos" class="hide" name="' + items[a].id + '-ypos" type="text" />';
        //$('#item-'+items[a].id).append(input_ypos);
        content += input_ypos;

        var trackerposition = '<input id="item-' + items[a].id + '-position" class="hide" name="' + items[a].id + '-position" type="text" value="' + tracker_count + '" />';
        //$('#item-'+items[a].id).append(trackerposition);
        content += trackerposition;

        var title = '<h2>' + items[a].title + '</h2>';
        //$('#item-'+items[a].id).prepend(title);
        content += title;

        var desc = '<input id="item-' + items[a].id + '-desc" class="hide" name="' + items[a].id + '-desc" type="text" value="' + items[a].desc + '" />';
        //$('#item-'+items[a].id).append(desc);
        content += desc;

        var trackitems = '<div class="select-items tracker-items hide"></div>';
        //$('#item-'+items[a].id).append(trackitems);
        content += trackitems;

        $('#item-' + items[a].id).append(content);

        $('#item-' + items[a].id).parent('.page').addClass('tracker-group');


        //if type img
        if (items[a].type_tracker == 'image') {

          //if true then display images in random order
          //console.log('random items');
          //console.log(items[a].random);
          random_items = items[a].random;
          if (random_items == true) {
            items[a].items = items[a].items.sort(function () {
              return .5 - Math.random();
            });
          }

          $.each(items[a].items, function (g) {
            var title = items[a].items[g]["title"] ? '<span>'+ items[a].items[g]["title"] +'</span>' : '';
            var countDown = items[a].items[g]["counter"] ? '<span class="counter" data-time="'+ items[a].items[g]["counter"] +'"><span class="hours">00</span>:<span class="minutes">00</span>:<span class="seconds">00</span></span>' : '';
            var info = '<div class="input-item--info">'+ title + countDown + '</div>';
            var sub_content =
              '<div class="tracker-select tracker-select-' + g + ' tracker-select--image" \
                    data-type="' + items[a].type_tracker + '" \
                    data-value="' + items[a].items[g]["name"] + '" \
                    data-img="' + items[a].items[g]['content'] + '"\
                    data-counter="" >\
                    <label> \
                      <input type="radio" name="' + items[a].id + '-selected" value="' + (Number(g) + 1) + '" /> \
                        <div class="input-item"> \
                          <img src="' + items[a].items[g]['content'] + '" alt="' + items[a].items[g]["name"] + '" /> \
                          ' + info + ' \
                        </div> \
                    </label> \
              </div>';
            $('#item-' + items[a].id).find('.tracker-items').append(sub_content);
          });
        }


        //if type text
        if (items[a].type_tracker == 'text') {

          //if true then display images in random order
          //console.log('random items');
          //console.log(items[a].random);

          random_items = items[a].random;
          if (random_items == true) {
            items[a].items = items[a].items.sort(function () {
              return .5 - Math.random();
            });
          }

          $.each(items[a].items, function (g) {
            var title = items[a].items[g]["title"] ? '<span>'+ items[a].items[g]["title"] +'</span>' : '';
            var countDown = items[a].items[g]["counter"] ? '<span class="counter" data-time="'+ items[a].items[g]["counter"] +'"><span class="hours">00</span>:<span class="minutes">00</span>:<span class="seconds">00</span></span>' : '';
            var info = '<div class="input-item--info">'+ title + countDown + '</div>';
            //for(g = 0; g < items[a].items.length; g++) {
            var sub_content = '<div class="tracker-select tracker-select-' + g + ' tracker-select--text" \
            data-type="' + items[a].type_tracker + '" \
            data-value="' + items[a].items[g]["name"] + '">\
            <label> \
              <input type="radio" name="' + items[a].id + '-selected" value="' + (Number(g) + 1) + '" /> \
              <div class="input-item"> \
                <p class="input-item--header">' + items[a].items[g]['content'] + '</p> \
                ' + info + ' \
              </div> \
            </label> \
            </div>';
            //$('#item-'+items[a].id).parent('.page').addClass('tracker-group');
            $('#item-' + items[a].id).find('.tracker-items').append(sub_content);
          });
        }

        var start_btn = '<div class="center"><button class="btn-start mt-4">start</button></div>';
        $('#item-' + items[a].id).append(start_btn);



      }

      //if type submit
      if (items[a].type == 'submit') {
        var content = '<p>' + items[a].text + '</p></br><input id="form-submit" type="submit" value="' + items[a].btn_value + '" />';
        $('#item-' + items[a].id).append(content);
      }

      //if type next
      if (items[a].type == 'next') {
        var content = '<button class="btn-next btn-next--page">' + items[a].text + '</button>';
        $('#item-' + items[a].id).append(content);
      }

      //if is ref and not likert add next button

      if (typeof ref != "undefined") {
        if (items[a].type != 'likert') {
          var content = '<div><button class="btn-next">weiter</button></div>';
          $('#item-' + items[a].id).append(content);
        }
      }

      if (items[a].type == 'consideration') {
        consideration_page = true;
        var content = '<h2>' + items[a].title + '</h2>';

        if ("subtitle" in items[a]) {
          content += '<p>' + items[a].subtitle + '</p>';
        }

        if ("include_text" in items[a]) {
          consideration_include_text = items[a].include_text;
        }

        content += '<div class="consideration-options select-items"></div>';
        $('#item-' + items[a].id).append(content);
        $('#item-' + items[a].id).parent('.page').addClass('consideration-group');
      }

    }

  }); //loop through pages

  return tracker_count;
}

//parse json
function parseJSON() {
  var finish = false;

  var pages_total = 0;
  var pages_current = 0;

  //console.log(blocks);

  $.each(blocks, function (s, block_item) {

    random_pages = false;
    if (block_item.options) {
      random_pages = block_item.options.random;
    }
    if (block_item.pages) {
      var pages = block_item.pages;
      var pages_count = pages.length;
      pages_total += pages_count;
      pages_current = pages_total - pages_count;

      //console.log('---block_item---');
      //console.log(block_item.pages);
      //console.log(pages_count);
      //console.log(pages_current);

      //parse blocks with pages
      tracker_count = parseBlocks(pages, random_pages, pages_current);
    }

    //console.log('blocks loops finsih');

  });

  finish = true;

  var obj = {
    finish: finish,
    tracker_count: tracker_count,
    windowWidth: window.innerWidth,
    windowHeight: window.innerHeight,
    screenWidth: window.outerWidth,
    screenHeight: window.outerHeight
  };

  return obj;
}

function slider(sliderEl) {

  sliderEl.owlCarousel({
    loop: false,
    items: 1,
    animateOut: 'fadeOut',
    animateIn: 'fadeIn',
    margin: 10,
    dots: true,
    nav: false,
    mouseDrag: false,
    touchDrag: false,
  });

  sliderEl.off('keydown.bs.carousel');

  sliderEl.find('.owl-dot').attr("disabled", "disabled");
  sliderEl.find('.owl-dot').attr("aria-hidden", "true");
  sliderEl.find('.owl-dot').attr("tabindex", "-1");
  sliderEl.find('.active').attr("aria-hidden", "false");
  sliderEl.find('.owl-item').attr("aria-hidden", "true");
  sliderEl.find('fieldset').find('input').attr("disabled", "disabled");
  sliderEl.find('.active').attr("aria-hidden", "false");
  sliderEl.find('.active').find('fieldset').find('input').removeAttr('disabled');

  sliderEl.trigger('refresh.owl.carousel');

  $('.btn-next--page').on('click', function (e) {
    e.preventDefault();

    nextslide(sliderEl);

    //if (owl.currentItem + 1 === owl.itemsAmount) {
    //alert('THE END');
    //}
  });

  sliderEl.on('change.owl.carousel', function(event) {
    $(event.currentTarget).find('.owl-item.active').attr("aria-hidden", "true");
    $(event.currentTarget).find('.owl-dot.active').attr("aria-hidden", "true");
    
  })

  sliderEl.on('changed.owl.carousel', function(event) {
    var newSlideIndex = event.item.index;
    var currentItem = event.relatedTarget._items[newSlideIndex];
    var isConsiderationGroup = currentItem.find('.consideration-group').length === 1 ? true : false;
    var isTrackerGroup = currentItem.find('.tracker-group').length === 1 ? true : false;

    if(isTrackerGroup) {
      var trackerGroup = currentItem.find('.tracker-group');
      showTracker(trackerGroup)
    }

    if(isConsiderationGroup) {
      var considerationElement = currentItem.find('.consideration-group');
      considerationGroup(considerationElement);
    }
    
    setTimeout(function () {
      $(event.currentTarget).find('.owl-item.active').attr("aria-hidden", "false");
      $('.owl-dots').find('.active').attr("aria-hidden", "false");
      $(event.currentTarget).find('.active').find('fieldset').find('input').removeAttr('disabled');
    }, 200);
  })

}

//next slide

function nextslide(slider) {
  slider = slider != undefined ? slider : sliderEl;
  slider.trigger('next.owl.carousel');
}

//convert Umlaute 

function deUmlaut(value) {
  value = value.toLowerCase();
  value = value.replace(/ä/g, 'ae');
  value = value.replace(/ö/g, 'oe');
  value = value.replace(/ü/g, 'ue');
  value = value.replace(/ß/g, 'ss');
  value = value.replace(/ /g, '-');
  value = value.replace(/\./g, '');
  value = value.replace(/,/g, '');
  value = value.replace(/\(/g, '');
  value = value.replace(/\)/g, '');
  return value;
}

//countDown function getTimeRemaining

function getTimeRemaining(endtime) {
  var total = Date.parse(endtime) - Date.parse(new Date());
  var seconds = Math.floor((total / 1000) % 60);
  var minutes = Math.floor((total / 1000 / 60) % 60);
  var hours = Math.floor((total / (1000 * 60 * 60)) % 24);
  var days = Math.floor(total / (1000 * 60 * 60 * 24));
  
  return {
    total,
    days,
    hours,
    minutes,
    seconds
  };
}

//countDown function initializeClock

function initializeClock(element, endtime) {
  const clock = $(element);
  const daysSpan = clock.find('.days');
  const hoursSpan = clock.find('.hours');
  const minutesSpan = clock.find('.minutes');
  const secondsSpan = clock.find('.seconds');

  function updateClock() {
    const t = getTimeRemaining(endtime);

    daysSpan.text(t.days);
    hoursSpan.text(('0' + t.hours).slice(-2));
    minutesSpan.text(('0' + t.minutes).slice(-2));
    secondsSpan.text(('0' + t.seconds).slice(-2));

    if (t.total <= 0) {
      clearInterval(timeinterval);
    }
  }

  updateClock();
  var timeinterval = setInterval(updateClock, 1000);

  return timeinterval;
}


// start all CountDowns in a trackerGroup

function startCountDowns(trackerGroup) {

  window.intervalList = new Array();
  var trackerItems = trackerGroup.find('.tracker-items .tracker-select');
  
  $(trackerItems).each(function (index) {
    var item = $(this);

    var itemTimer = item.find('.counter');

    //console.log('itemTimer', itemTimer);
   
    if(itemTimer.length > 0) {
      var time = itemTimer.attr('data-time');
      //console.log('timer', time);
      time = parseInt(time);
      var deadline = new Date(Date.parse(new Date()) + time * 1000);
      var countDownTimer = initializeClock(itemTimer, deadline);
      window.intervalList.push(countDownTimer)
    }
  });
}

function stopAllIntervals(intervalList) {
  if(intervalList.length > 0) {
    for(var i in intervalList) {
      clearInterval(intervalList[i]);
    }
    window.intervalList = new Array();
  }
}

//count hover foreach item 
function countHover(trackerGroup) {
  var trackerID = trackerGroup.find('> .tracker').attr('id').replace('item-', '');
  var trackerItems = trackerGroup.find('.tracker-items .tracker-select');
  //console.log('trackeritems', trackerItems);

  var trackerItemsValue = [];

  trackerGroup['id'] = trackerID;

  $(trackerItems).each(function (index) {
    var item = $(this);
    var timer = 0;
    var counter = 0;
    var trackerItemValues = {};
    trackerItemsValue.push('');

    var itemName = item.attr('data-value').toLowerCase().replace(/\s/g, '');
    itemName = deUmlaut(itemName);

    trackerItemValues = {
      name: itemName,
      timer: 0,
      counter: 0,
      position: index + 1,
      group: trackerID
    }

    trackerItemsValue[index] = trackerItemValues;
    trackedGroups.set(trackerID, trackerItemsValue);

    //console.log('trackedGroups', trackedGroups);

    item.on('mouseenter', function () {
      //console.log(index + 1);
      startTimer();
    });
    item.on('mouseleave', function () {
      //console.log(index + 1);

      // console.log('itemName', trackerID + '-' + itemName);

      var currentTime = stopTimer();
      timer += currentTime;
      counter += 1;

      trackerItemValues = {
        name: itemName,
        timer: timer,
        counter: counter,
        position: index + 1,
        group: trackerID
      }

      // trackerItemValues['name'] = itemName;
      // trackerItemValues['timer'] = timer;
      // trackerItemValues['counter'] = counter;
      // trackerItemValues['position'] = index + 1;
      // trackerItemValues['group'] = trackerID;

      // console.log(timer);
      // console.log(counter);
      // console.log(itemName);

      trackerItemsValue[index] = trackerItemValues;

      // console.log(trackerItemsValue);
      //trackedGroups[trackerID] = trackerItemsValue;
      trackedGroups.set(trackerID, trackerItemsValue);
    });
  });
}

//start the tracker Group 

function showTracker(trackerGroup) {
    var btnStart = trackerGroup.find('.btn-start');

    btnStart.on('click', function (e) {
      e.preventDefault();
      trackerGroup.find('.tracker-items').removeClass('hide');
      trackerGroupQuestions(trackerGroup);
      startCountDowns(trackerGroup);
      startrecord();
      countHover(trackerGroup);
      btnStart.remove();
    })
}

//consideration group

function considerationGroup(item) {
  var $itemgroup = item.find('input[type="radio"]').attr('name');
    //console.log($itemgroup);
    $('[name="' + $itemgroup + '"]').change(function () {
      if ($(this).is(':checked')) {
        nextslide();
      }
    });
}

// next question in a tracker group

function trackerGroupQuestions(trackerGroup) {
  var $itemgroup = trackerGroup.find('input[type="radio"]').attr('name');

    $('[name="' + $itemgroup + '"]').change(function () {

      if ($(this).is(':checked')) {
        // Do something...
        stoprecording();
        //console.log('stop');
        //console.log(xpos);
        //console.log(ypos);

        var item = $(this).closest('.item');
        var item_id = item.attr('id');
        var input_fields = [];

        if (consideration_page == true) {
          var selected = $(this).closest('.tracker-select');
          var selected_type = selected.attr('data-type');
          var selected_name = selected.attr('data-value');
          var selected_img = selected.attr('data-img');
          var selected_info = selected.find('.input-item--info').length > 0 ? selected.find('.input-item--info').clone() : false;

          //console.log(selected_name);
          //console.log(selected_img);
          //console.log(selected_type);

          if (selected_type == 'text' && consideration_include_text == true) {
            var selected_value = '<p class="input-item--header">' + selected_name + '</p>';
            selected_info = $('<div>').append(selected_info).html();
            var option = '<div class="tracker-select tracker-select--' + selected_type + '" data-value="' + selected_name + '"><label><input type="radio" name="item-consideration" value="' + selected_name + '" /><div class="input-item">' + selected_value + selected_info +'</div></label></div>';
            $('[data-type="consideration"]').find('.consideration-options').append(option);
          }

          if (selected_type == 'image') {
            if (selected_img != undefined || selected_img != null) {
              var selected_value = '<img src="' + selected_img + '" alt="' + selected_name + '" />';
              selected_info = $('<div>').append(selected_info).html();
              var option = '<div class="tracker-select tracker-select--' + selected_type + '" data-value="' + selected_name + '"><label><input type="radio" name="item-consideration" value="' + selected_name + '" /><div class="input-item">' + selected_value + selected_info +'</div></label></div>';
              $('[data-type="consideration"]').find('.consideration-options').append(option);
            }
          }

          // console.log(selected_value);
        }

        //stop countDowns if there are any running
        if(window.intervalList.length > 0) {
          stopAllIntervals(window.intervalList);
        }

        item.addClass('disabled');
        item.find('.select-items input:checked').parent().parent().addClass('selected');
        item.find('.select-items .tracker-select:not(.selected)').addClass('hide');
        item.find('.select-items').css('justify-content', 'center');

        item.find('input[type=text]').each(function () {
          var this_id = $(this).attr('id');
          input_fields.push(this_id);
        });

        //console.log(input_fields);

        //$('#'+input_id).val(xpos);
        $('#' + item_id + '-xpos').val(xpos);
        $('#' + item_id + '-ypos').val(ypos);

        if ($('#' + item_id).next('.item').length) {
          var nextq = $('#' + item_id).parent().find('.ref');
          nextq.first().removeClass('hide').addClass('show');
          //console.log('Number of Siblings:');
          //console.log(nextq.length);
          nextq.each(function () {
            var thisitem = $(this);

            if ($(this).has('.likert')) {
              thisitem.find('input[type=radio]').change(function () {
                if (thisitem.closest('.item').next('.ref').length) {
                  thisitem.closest('.item').removeClass('show').addClass('hide');
                  thisitem.closest('.item').next('.ref').removeClass('hide').addClass('show');
                } else {
                  nextslide();
                }
              });
            }

            if ($(this).not('.likert')) {
              thisitem.find('.btn-next').on('click', function (e) {
                e.preventDefault();
                if (thisitem.closest('.item').next('.ref').length) {
                  thisitem.closest('.item').removeClass('show').addClass('hide');
                  thisitem.closest('.item').next('.ref').removeClass('hide').addClass('show');
                } else {
                  nextslide();
                }
              });
            }

          });
        } else {
          //next slide
          nextslide();
        }
      };
    });
}

//download file

function download(filename, text) {
  var dlb = document.createElement('a');
  dlb.setAttribute('href', 'data:text/csv;charset=utf-8,' + encodeURIComponent(text));
  dlb.setAttribute('download', filename);

  dlb.style.display = 'none';
  document.body.appendChild(dlb);

  dlb.click();

  document.body.removeChild(dlb);
}

//convert array to comma list
function toCSV(obj, separator) {
  var arr = [];

  for (var key in obj) {
    if (obj.hasOwnProperty(key)) {
      arr.push(obj[key]);
    }
  }

  return arr.join(separator || ",");
}

// console.log('window.innerWidth', window.innerWidth);
// console.log('window.innerHeight', window.innerHeight);

// save form
function save_form(finish) {
  jQuery('#' + form_id).submit(function (event) { // use jQuery no conflict methods replace $ with "jQuery"
    event.preventDefault(); // stop post action
    var formData = jQuery('#' + form_id).serializeArray();
    var trackedGroupItemsMax = 0;

    //output data
    //console.log('formData', formData);
    //console.log('trackerGroups', trackedGroups);

    trackedGroups.forEach((value, key) => {
      if(trackedGroupItemsMax < value.length) {
        trackedGroupItemsMax = value.length
      }
    });

    //console.group('---tracker_count---');
    //console.log(finish.tracker_count);
    //console.log(maxcount);
    //console.groupEnd();

    //create arrays

    var tracker_item = [];
    var tracker_item_name = '';
    var tracker_items_all = [];
    var tracker_items = [];

    var tracker_header = [];
    var tracker_content = [];
    //var tracker_count = 0;

    var list_header = new Map();
    var list_content = [];

    //add mandatory survey fields
    list_header.set('UID');
    list_content.push(UIDrandom);

    list_header.set('Window Inner Width');
    list_content.push(finish.windowWidth);

    list_header.set('Window Inner Height');
    list_content.push(finish.windowHeight);

    list_header.set('Screen Width');
    list_content.push(finish.screenWidth);

    list_header.set('Screen Height');
    list_content.push(finish.screenHeight);

    list_header.set('TrialID');
    list_content.push(TrialID);

    list_header.set('execution-date');
    list_content.push(CurrentDateFormat);

    //loop through formData items
    for (var h = 0; h < formData.length; h++) {
      var name = formData[h].name;
      var value = formData[h].value;

      //all but tracker
      if (name.toLowerCase().indexOf("tracker") < 0) {
        value = value.replace(/,/g, ".")
        if (!list_header.has(name)) {
          list_header.set(name);
        }
        list_content.push(value);
      }

      //all tracker items
      if (name.toLowerCase().includes("tracker") === true) {
        tracker_items_all.push(formData[h]);
      }

    } //loop formData items

    //find max length trackGroup
    // for (var i = 1; i <= parseInt(finish.tracker_count); i++) {
    //   tracker_item_name = "tracker" + i;
    //   var trackedGroupItems = trackedGroups.get(tracker_item_name);
    //   trackedGroupItemsMax < trackedGroupItems.length ? trackedGroupItemsMax = trackedGroupItems.length : trackedGroupItemsMax;
    // }

    //console.log('finish.tracker_count', finish.tracker_count);
    //all tracker names
    for (var i = 1; i <= parseInt(finish.tracker_count); i++) {

      tracker_item_name = "tracker" + i;
      var tracker_item_content = {};
      tracker_item_content['id'] = tracker_item_name;
      var trackedGroupItems = trackedGroups.get(tracker_item_name);


      // trackedGroupItems.forEach((value, key) => {
      //   // console.log('trackedGroupItems key', key);
      //   // console.log('trackedGroupItems value', value);

      //   if (!list_header.has('product-' + (key + 1))) {
      //     list_header.set('product-' + (key + 1));
      //     list_header.set('product-' + (key + 1) + '-counter');
      //     list_header.set('product-' + (key + 1) + '-position');
      //     list_header.set('product-' + (key + 1) + '-timer');
      //   }
      // });


      //console.log('tracker_items_all', tracker_items_all);

      for (var h = 0; h < tracker_items_all.length; h++) {

        var name = tracker_items_all[h].name;
        var value = tracker_items_all[h].value;

        if (name.toLowerCase().indexOf(tracker_item_name) >= 0) {
          if (name.toLowerCase().indexOf("position") >= 0) {
            tracker_item_content['position'] = value;
          }
          else if (name.toLowerCase().indexOf("desc") >= 0) {
            tracker_item_content['desc'] = value;
          }
          else if (name.toLowerCase().indexOf("xpos") >= 0) {

            var list_time = [];

            var list_x = value.slice(0, -1);
            list_x = list_x.split(",");

            var list_x_length = parseInt(list_x.length);

            if (list_x_length < maxcount) {
              for (var j = list_x_length; j < maxcount; j++) {
                list_x.push(" ");
              }
            }

            list_x = list_x.toString();

            //build time array
            for (var k = 1; k <= list_x_length; k++) {
              list_time.push(k * period);
            }

            var list_time_length = parseInt(list_time.length);

            if (list_time_length < maxcount) {
              for (var l = list_time_length; l < maxcount; l++) {
                list_time.push(" ");
              }
            }

            list_time = list_time.toString();

            tracker_item_content['xpos'] = list_x;
            tracker_item_content['time'] = list_time;
          }
          else if (name.toLowerCase().indexOf("ypos") >= 0) {

            var list_y = value.slice(0, -1);
            list_y = list_y.split(",");

            var list_y_length = parseInt(list_y.length);

            if (parseInt(list_y_length) < maxcount) {
              for (var j = parseInt(list_y_length); j < maxcount; j++) {
                list_y.push(" ");
              }
            }

            list_y = list_y.toString();

            tracker_item_content['ypos'] = list_y;
          }

          else if (name.toLowerCase().indexOf("selected") >= 0) {
            tracker_item_content['selected'] = value;
          }

          // else if (name.toLowerCase().indexOf("-name-0") >= 0) {
          //   tracker_item_content['options_left'] = value;
          // }

          // else if (name.toLowerCase().indexOf("-name-1") >= 0) {
          //   tracker_item_content['options_right'] = value;
          // }

          else {
            //tracker_item_content[name] = value;
            value = value.replace(/,/g, ".")
            if (!list_header.has(name)) {
              list_header.set(name);
            }
            list_content.push(value);
          }

        }

        trackedGroupItems.forEach((value, key) => {
          tracker_item_content['product-' + (key + 1)] = value.name;
          tracker_item_content['product-' + (key + 1) + '-counter'] = value.counter;
          tracker_item_content['product-' + (key + 1) + '-position'] = value.position;
          tracker_item_content['product-' + (key + 1) + '-timer'] = value.timer;
        });

        if (trackedGroupItems.length < trackedGroupItemsMax) {
          for (var i = trackedGroupItems.length + 1; i <= trackedGroupItemsMax; i++) {
            tracker_item_content['product-' + i] = "0";
            tracker_item_content['product-' + i + '-counter'] = "0";
            tracker_item_content['product-' + i + '-position'] = "0";
            tracker_item_content['product-' + i + '-timer'] = "0";
          }
        }

      }

      tracker_item.push(tracker_item_content);
      //console.log('tracker_item_content', tracker_item_content);
    }


    //sort tracker
    for (var i = 1; i <= finish.tracker_count; i++) {

      tracker_item_name = "tracker" + i;

      var marvel = tracker_item.filter(function (el) {

        return el.id === tracker_item_name;
      });

      tracker_items.push(marvel);
    }

    //get values for each tracker
    var tracker_rows = [];
    for (var i = 0; i < tracker_items.length; i++) {

      var tracker_row = {};
      var sorted_row_sorted = [];
      //console.log(tracker_items[i]);
      $.each(tracker_items[i], function (key, value) {
        $.each(value, function (k, v) {
          tracker_row[k] = v;
        });
      });

      sorted_row = sortObject(tracker_row);

      $.each(sorted_row, function (key, value) {
        sorted_row_sorted.push(value);
      });
      tracker_rows.push(sorted_row_sorted);

    }

    // console.log('tracker_rows', tracker_rows);
    // console.log('sorted_row', sorted_row);
    //build teh tracker header
    $.each(sorted_row, function (key, value) {
      // console.log('---sorted keyy ---');
      // console.log(key);
      if (key !== 'xpos' && key !== 'ypos' && key !== 'time') {
        tracker_header.push(key);
      }
    });


    tracker_header = tracker_header.toString() + ',';
    list_header = Array.from(list_header.keys()).join(", ");
    list_content = list_content.toString() + ',';


    //push tracker rows to content
    for (var i = 0; i < tracker_rows.length; i++) {
      var tracker_rows_string = tracker_rows[i].toString();
      tracker_content += list_content + tracker_rows_string + "\n";
    }



    //Outout Data to file
    var header = "";
    var content = "";

    //push data to header

    //create header

    header += list_header + ', ' + tracker_header;

    for (var i = 1; i <= maxcount; i++) {
      header += "T_" + i + ",";
    }

    for (var i = 1; i <= maxcount; i++) {
      header += "X_" + i + ",";
    }
    for (var i = 1; i <= maxcount; i++) {
      header += "Y_" + i + ",";
    }

    //push data to content
    content += tracker_content;

    // console.log('list header', list_header);
    // console.log('tracker_content', tracker_content);
    // console.log('trackedGroupItemsMax', trackedGroupItemsMax);
    // console.log('final header', header);
    // console.log('--------------');

    //build file content
    var file_content = header + "\n" + content;

    // console.group('formdata output');
    // console.log(file_content);
    // console.groupEnd();

    var filename = '' + FilenamePrefix + '-' + UIDrandom + '-' + CurrentDateMil + '';
    download(filename, file_content);

  });
}

$(document).ready(function () {
  var finish = parseJSON();
  if (finish.finish == true) {
    slider(sliderEl);
    save_form(finish);
  }
});
